function toggle(box) {
    return function () {
        if (box.classList.contains('is-active')) {
            box.classList.remove('is-active');
        } else {
            box.classList.add('is-active');
        }
    }
}

function findAncestor(el, cls) {
    while ((el = el.parentElement) && !el.classList.contains(cls));
    return el;
}

function bind_toggle() {
    var topElement = document.body;  // Assuming the whole document should be searched
    var nodes = topElement.getElementsByClassName('collapse');
    Array.from(nodes).forEach(node => {
        Array.from(node.getElementsByClassName('unbox')).forEach(box => {
            var heading = box.getElementsByClassName('heading')[0];
            if (heading) {
                heading.addEventListener('click', toggle(box));
            }
        });
    });
}

function docReady(fn) {
    if (document.readyState === "complete" || document.readyState === "interactive") {
        setTimeout(fn, 1);
    } else {
        document.addEventListener("DOMContentLoaded", fn);
    }
}

docReady(bind_toggle);

function playAudio(element) {
    var sources = [element.getAttribute('data-src-mp3'), element.getAttribute('data-src-ogg')]; // 获取MP3和OGG源
    var audio = new Audio();

    function tryNextSource() {
        if (sources.length === 0) {
            console.error("No more audio sources to try.");
            return;
        }
        
        var currentSource = sources.shift(); // 取出一个音频源尝试播放
        audio.src = currentSource;
        audio.play().catch(tryNextSource); // 如果当前音频源播放失败，则尝试下一个音频源
    }

    tryNextSource();
}

document.addEventListener("DOMContentLoaded", function() {
    var audioLinks = document.querySelectorAll('.audio_play_button'); // 选择所有音频播放按钮
    audioLinks.forEach(link => {
        link.onclick = function() {
            playAudio(this); // 点击时调用 playAudio 函数，并传递当前元素作为参数
        };
    });
});

function _dtPlayAudio(element) {
    var sources = [element.getAttribute('data-src-mp3'), element.getAttribute('data-src-ogg')];
    var audio = new Audio();

    function tryNextSource() {
        if (sources.length === 0) {
            console.error("No more audio sources to try.");
            return;
        }
        
        var currentSource = sources.shift();
        audio.src = currentSource;
        audio.play().catch(tryNextSource);
    }

    tryNextSource();
}

document.addEventListener("DOMContentLoaded", function() {
    var audioLinks = document.querySelectorAll('.audio_play_button');
    audioLinks.forEach(link => {
        link.onclick = function() {
            _dtPlayAudio(this);
        };
    });
});